## xmms2 0.8+dfsg

=== wscript ===
# encoding: utf-8
#
# WAF build scripts for XMMS2
# Copyright (C) 2006-2001 XMMS2 Team
#

import sys
if sys.version_info < (2,4):
    raise RuntimeError("Python 2.4 or newer is required")

import os

# Waf removes the current dir from the python path. We readd it to import waf
# tools stuff.
sys.path.insert(0, os.getcwd())

from waflib import Configure, Options, Utils, Errors, Logs

from waftools.compiler_flags import compiler_flags
from waftools import gittools

BASEVERSION="0.8 DrO_o"
APPNAME='xmms2'

top = '.'
out = '_build_'

_waf_hexversion = 0x01060700
_waf_mismatch_msg = """
You are building xmms2 with a waf version that is different from the one
distributed with xmms2. This is not supported by the XMMS2 Team. Before
reporting any errors with this setup, please rebuild XMMS2 using './waf
configure build install'
"""

####
## Patch undefine so that HAVE_* envs are still defined after
## we write the configuration header file.
####
@Configure.conf
def undefine(self, key):
    ban = key + '='
    lst = [x for x in self.env['DEFINES'] if not x.startswith(ban)]
    self.env['DEFINES'] = lst
    self.env.append_unique('define_key', key)

####
## Initialization
####
def init(ctx):
    import gc
    gc.disable()

    from waflib import Context
    if _waf_hexversion != Context.HEXVERSION:
        Logs.warn(_waf_mismatch_msg)

subdirs = """
src/lib/xmmstypes
src/lib/xmmssocket
src/lib/xmmsipc
src/lib/xmmsutils
src/lib/xmmsvisualization
src/clients/lib/xmmsclient
src/clients/lib/xmmsclient-glib
src/include
src/includepriv
""".split()

optional_subdirs = """
src/clients/nycli
src/clients/launcher
src/clients/et
src/clients/mdns
src/clients/medialib-updater
src/clients/vistest
src/clients/lib/xmmsclient-ecore
src/clients/lib/xmmsclient++
src/clients/lib/xmmsclient++-glib
src/clients/lib/xmmsclient-cf
src/clients/lib/python
src/clients/lib/perl
src/clients/lib/ruby
tests
pixmaps
""".split()

def is_plugin(x):
    return os.path.exists(os.path.join("src/plugins", x, "wscript"))

all_optionals = set(os.path.basename(o) for o in optional_subdirs)
all_plugins = set(p for p in os.listdir("src/plugins") if is_plugin(p))

def get_newest(*dirs):
    m = 0
    for d in dirs:
        m = max([m]+[os.stat(os.path.join(sd, "wscript")).st_mtime for sd in d])
    return m

####
## Build
####
def build(bld):
    if bld.env.BUILD_XMMS2D:
        subdirs.append("src/xmms")

    plugins = bld.env.XMMS_PLUGINS_ENABLED
    plugindirs = ["src/plugins/%s" % plugin for plugin in plugins]
    optionaldirs = bld.env.XMMS_OPTIONAL_BUILD

    newest = get_newest(subdirs, plugindirs, optionaldirs)
    if bld.env.NEWEST_WSCRIPT_SUBDIR and newest > bld.env.NEWEST_WSCRIPT_SUBDIR:
        bld.fatal("You need to run waf configure")
        raise SystemExit()

    bld.add_subdirs(subdirs)
    bld.add_subdirs(plugindirs)
    bld.add_subdirs(optionaldirs)

    for name, lib in bld.env.XMMS_PKGCONF_FILES:
        bld(features = 'subst',
            source = 'xmms2.pc.in',
            target = name + '.pc',
            install_path = '${PKGCONFIGDIR}',
            NAME = name,
            LIB = lib+' ', # Avoid error in waf 1.6 if lib == ''
            PREFIX = bld.env.PREFIX,
            BINDIR = bld.env.BINDIR,
            LIBDIR = bld.env.LIBDIR,
            INCLUDEDIR = os.path.join(bld.env.INCLUDEDIR, "xmms2"),
            VERSION = bld.env.VERSION
            )

    bld.install_files('${SHAREDDIR}', "silence-cellule_snippet.ogg")

    bld.add_post_fun(shutdown)

####
## Configuration
####
def _configure_optionals(conf):
    """Process the optional xmms2 subprojects"""
    def _check_exist(optionals, msg):
        unknown_optionals = optionals.difference(all_optionals)
        if unknown_optionals:
            conf.fatal(msg%dict(unknown_optionals=', '.join(unknown_optionals)))
            raise SystemExit()
        return optionals

    conf.env.XMMS_OPTIONAL_BUILD = []

    if conf.options.enable_optionals is not None:
        selected_optionals = _check_exist(set(conf.options.enable_optionals),
                "The following optional(s) were requested, "
                "but don't exist: %(unknown_optionals)s")
        optionals_must_work = True
    elif conf.options.disable_optionals is not None:
        disabled_optionals = _check_exist(set(conf.options.disable_optionals),
                "The following optional(s) were disabled, "
                "but don't exist: %(unknown_optionals)s")
        selected_optionals = all_optionals.difference(disabled_optionals)
        optionals_must_work = False
    else:
        selected_optionals = all_optionals
        optionals_must_work = False

    failed_optionals = set()
    succeeded_optionals = set()

    for o in selected_optionals:
        x = [x for x in optional_subdirs if os.path.basename(x) == o][0]
        try:
            conf.sub_config(x)
            conf.env.append_value('XMMS_OPTIONAL_BUILD', x)
            succeeded_optionals.add(o)
        except Errors.ConfigurationError:
            failed_optionals.add(o)

    if optionals_must_work and failed_optionals:
        conf.fatal("The following required optional(s) failed to configure: %s"
                % ', '.join(failed_optionals))
        raise SystemExit(1)

    disabled_optionals = set(all_optionals)
    disabled_optionals.difference_update(succeeded_optionals)

    return succeeded_optionals, disabled_optionals

def _configure_plugins(conf):
    """Process ll xmms2d plugins"""
    def _check_exist(plugins, msg):
        unknown_plugins = plugins.difference(all_plugins)
        if unknown_plugins:
            conf.fatal(msg%dict(unknown_plugins=', '.join(unknown_plugins)))
            raise SystemExit(1)
        return plugins

    conf.env.XMMS_PLUGINS_ENABLED = []

    if conf.options.enable_plugins is not None:
        selected_plugins = _check_exist(set(conf.options.enable_plugins),
                "The following plugin(s) were requested, "
                "but don't exist: %(unknown_plugins)s")
        disabled_plugins = all_plugins.difference(selected_plugins)
        plugins_must_work = True
    elif conf.options.disable_plugins is not None:
        disabled_plugins = _check_exist(set(conf.options.disable_plugins),
                "The following plugin(s) were disabled, "
                "but don't exist: %(unknown_plugins)s")
        selected_plugins = all_plugins.difference(disabled_plugins)
        plugins_must_work = False
    elif conf.options.without_xmms2d:
        disabled_plugins = all_plugins
        selected_plugins = set()
        plugins_must_work = False
    else:
        selected_plugins = all_plugins
        disabled_plugins = set()
        plugins_must_work = False

    for plugin in selected_plugins:
        try:
            conf.sub_config("src/plugins/%s" % plugin)
            if (not conf.env.XMMS_PLUGINS_ENABLED or
                    (len(conf.env.XMMS_PLUGINS_ENABLED) > 0 and
                        conf.env.XMMS_PLUGINS_ENABLED[-1] != plugin)):
                disabled_plugins.add(plugin)
        except Errors.ConfigurationError:
            disabled_plugins.add(plugin)

    if plugins_must_work:
        broken_plugins = selected_plugins.intersection(disabled_plugins)
        if broken_plugins:
            conf.fatal("The following required plugin(s) failed to configure: "
                    "%s" % ', '.join(broken_plugins))
            raise SystemExit(1)

    return conf.env.XMMS_PLUGINS_ENABLED, disabled_plugins

def _output_summary(enabled_plugins, disabled_plugins,
                    enabled_optionals, disabled_optionals,
                    output_plugins):
    enabled_plugins = [x for x in enabled_plugins if x not in output_plugins]
    Logs.pprint('Normal', "\n")

    Logs.pprint('Normal', "Optional configuration:\n"
                          "=======================")
    Logs.pprint('Normal', "Enabled: ", sep='')
    Logs.pprint('BLUE', ', '.join(sorted(enabled_optionals)))
    Logs.pprint('Normal', "Disabled: ", sep='')
    Logs.pprint('BLUE', ', '.join(sorted(disabled_optionals)))

    Logs.pprint('Normal', "Plugins configuration:\n"
                          "======================")
    Logs.pprint('Normal', 'Output: ', sep='')
    Logs.pprint('BLUE', ', '.join(sorted(output_plugins)))
    Logs.pprint('Normal', 'XForm/Other: ', sep='')
    Logs.pprint('BLUE', ', '.join(sorted(enabled_plugins)))
    Logs.pprint('Normal', 'Disabled: ', sep='')
    Logs.pprint('BLUE', ', '.join(sorted(disabled_plugins)))

def configure(conf):
    has_platform_support = os.name in ('nt', 'posix')
    conf.msg('Platform code for %s' % os.name, has_platform_support)
    if not has_platform_support:
        conf.fatal('xmms2 only has platform support for Windows and POSIX operating systems.')
        raise SystemExit(1)

    if 'PKG_CONFIG_PREFIX' in os.environ:
        prefix = os.environ['PKG_CONFIG_PREFIX']
        if not os.path.isabs(prefix):
            pretix = os.path.abspath(prefix)
        conf.env.PKG_CONFIG_DEFINES = dict(prefix=prefix)

    conf.env.BUILD_XMMS2D = False
    if not conf.options.without_xmms2d:
        conf.env.BUILD_XMMS2D = True
        subdirs.insert(0, "src/xmms")

    conf.check_tool('gnu_dirs')
    conf.check_tool('man', tooldir=os.path.abspath('waftools'))
    conf.check_tool('misc')
    conf.check_tool('gcc')
    conf.check_tool('g++')

    if conf.options.target_platform:
        Options.platform = conf.options.target_platform

    nam,changed = gittools.get_info()
    conf.msg("git commit id", nam)
    if conf.options.customversion:
        conf.env.VERSION = "%s (%s + %s)" % (BASEVERSION, nam, conf.options.customversion)
    else:
        dirty = changed and "-dirty" or ""
        conf.msg("uncommited changed", changed and "yes" or "no")
        conf.env.VERSION = "%s (git commit: %s%s)" % (BASEVERSION, nam, dirty)

    conf.env.append_unique('CFLAGS', ['-g', '-O0'])
    conf.env.append_unique('CXXFLAGS', ['-g', '-O0'])

    if conf.options.with_profiling:
        conf.env.with_profiling = True
        conf.env.append_unique('CFLAGS', ['--coverage'])
        conf.env.append_unique('LINKFLAGS', ['--coverage'])

    flags = compiler_flags(conf)

    flags.enable_c_warning('all')
    flags.enable_c_warning('empty-body')
    flags.enable_c_warning('format=2')
    flags.enable_c_warning('format-nonliteral')
    flags.enable_c_warning('format-security')
    flags.enable_c_warning('ignored-qualifiers')
    flags.enable_c_warning('missing-prototypes')
    flags.enable_c_warning('strict-prototypes')
    flags.enable_c_warning('type-limits')
    flags.enable_c_warning('write-strings')

    flags.disable_c_warning('format-extra-args')
    flags.disable_c_warning('format-zero-length')

    flags.enable_feature('diagnostics-show-option')

    flags.enable_c_error('implicit-function-declaration')

    conf.env.XMMS_PKGCONF_FILES = []
    conf.env.XMMS_OUTPUT_PLUGINS = [(-1, "NONE")]

    if conf.options.pkgconfigdir:
        conf.env.PKGCONFIGDIR = conf.options.pkgconfigdir
        Logs.pprint('Normal', conf.env.PKGCONFIGDIR) #XXX What is it ?
    else:
        conf.env.PKGCONFIGDIR = os.path.join(conf.env.LIBDIR, 'pkgconfig')

    if conf.options.config_prefix:
        for d in conf.options.config_prefix:
            if not os.path.isabs(d):
                d = os.path.abspath(d)
            conf.env.prepend_value('LIBPATH', os.path.join(d, 'lib'))
            conf.env.prepend_value('CPPPATH', os.path.join(d, 'include'))

    if Options.platform != 'win32':
        conf.env.append_unique('CFLAGS_cstlib', ['-fPIC', '-DPIC'])
        conf.env.append_unique('CPPFLAGS_cxxshlib', ['-fPIC', '-DPIC'])
    else:
        # As we have to change target platform after the tools
        # have been loaded there are a few variables that needs
        # to be initiated if building for win32.

        # Make sure we don't have -fPIC and/or -DPIC in our CFLAGS
        conf.env.CFLAGS_cshlib = []
        conf.env.CXXFLAGS_cxxshlib = []

=== tests/wscript ===
#encoding: utf-8

types_suite = """
xmmsv/t_xmmsv.c
xmmsv/t_xmmsv_serialization.c
xmmsv/t_coll.c
""".split()

server_suite = """
server/t_streamtype.c
""".split()

test_xmmstypes_src = """
runner/main.c
runner/valgrind.c
""".split() + types_suite

test_server_src = """
runner/main.c
runner/valgrind.c
../src/xmms/streamtype.c
../src/xmms/object.c
""".split() + server_suite


def configure(conf):
    conf.load("unittest", tooldir="waftools")

    conf.check_cc(header_name="CUnit/CUnit.h")
    conf.check_cc(lib="cunit", uselib_store="cunit")
    conf.check_cc(lib="ncurses", uselib_store="ncurses", mandatory=False)

    code = """
           static void T (void) __attribute__ ((constructor (220)));
           static void T (void) {};
    """
    conf.check_cc(fragment=code, type="c", msg="Checking for constructor attribute")

    conf.check_cfg(package='valgrind', uselib_store='valgrind', args='--cflags', mandatory=False)


def build(bld):
    bld(features = 'c cprogram test',
        target = 'test_xmmstypes',
        source = test_xmmstypes_src,
        includes = '. .. runner ../src ../src/include',
        use = 'xmmstypes',
        uselib = 'cunit ncurses valgrind DISABLE_WRITESTRINGS',
        install_path = None
        )

    bld(features = 'c cprogram test',
        target = 'test_server',
        source = test_server_src,
        includes = '. .. runner ../src ../src/includepriv ../src/include',
        use = 'xmmstypes',
        uselib = 'cunit ncurses valgrind glib2 gthread2 DISABLE_WRITESTRINGS',
        install_path = None
        )


def options(o):
    o.load("unittest", tooldir="waftools")

=== src/include/wscript ===
import os

def build(bld):
    # FIXME: This is a test that should work.
    for d in bld.path.ant_glob('**', dir=True, src=False):
        rpath = d.path_from(bld.path)
        bld.recurse(rpath)
        f = d.ant_glob('*.h')
        if f:
            bld.install_files(os.path.join(bld.env.INCLUDEDIR, 'xmms2', rpath), f)

    #paths = ['xmms', 'xmmsc', 'xmmsclient', 'xmmsclient/xmmsclient++']
    #for p in paths:
        #bld.add_subdirs(p)
        #lst = os.listdir(os.path.join('src', 'include', p))
        #f = [os.path.join(p, a) for a in lst if a.endswith('.h')]
        #bld.install_files(os.path.join(bld.env.INCLUDEDIR, 'xmms2', p), " ".join(f))

def configure(conf):
    conf.sub_config("xmms")

    return True

def options(env):
    pass

=== src/includepriv/wscript ===
def configure(conf):
    return True
def options(conf):
    pass
def build(bld):
    bld.add_subdirs("xmmspriv")
    bld.add_subdirs("xmmsclientpriv")

=== src/xmms/wscript ===
# encoding: utf-8
#
# WAF build scripts for XMMS2
# Copyright (C) 2006-2011 XMMS2 Team
#

import os
from waflib import Options, Logs, Errors

source = """
    config.c
    mediainfo.c
    sqlite.c
    medialib.c
    object.c
    error.c
    output.c
    playlist.c
    collection.c
    collquery.c
    collserial.c
    collsync.c
    ipc.c
    log.c
    plugin.c
    magic.c
    ringbuf.c
    xform.c
    xform_plugin.c
    streamtype.c
    converter_plugin.c
    segment_plugin.c
    ringbuf_xform.c
    outputplugin.c
    bindata.c
    sample.genpy
    utils.c
    visualization/format.c
    visualization/object.c
    visualization/udp.c
    visualization/xform.c
""".split()

ipc_object_files = """
    bindata
    collection
    config
    main
    mediainfo
    medialib
    output
    playlist
    visualization/object
    xform
""".split()

def build(bld):
    for ipc_object_file in ipc_object_files:
        python_script = ipc_object_file + '_ipc.py'
        c_file = ipc_object_file + '_ipc.c'

        bld(source=['../ipc.xml', python_script],
            target=c_file,
            rule='${PYTHON} ${SRC[1].abspath()} > ${TGT}',
            before='c'
        )

    compat = [
        "compat/localtime_%s.c" % bld.env.localtime_impl,
        "compat/statfs_%s.c" % bld.env.statfs_impl,
        "compat/signal_%s.c" % bld.env.compat_impl,
        "compat/symlink_%s.c" % bld.env.compat_impl,
        "compat/checkroot_%s.c" % bld.env.compat_impl,
        "compat/thread_name_%s.c" % bld.env.thread_name_impl,
        "visualization/%s.c" % bld.env.visualization_impl
    ]

    bld(features='c ' + (bld.env.xmms_shared_library and 'cshlib' or 'cstlib'),
        target = 'xmms2core',
        source = source + compat,
        includes = '. ../.. ../include ../includepriv',
        uselib = 'glib2 gmodule2 gthread2 sqlite3 statfs socket shm valgrind',
        use = 'xmmsipc xmmssocket xmmsutils xmmstypes xmmsvisualization'
    )

    objects = []
    if bld.env.xmms_icon:
        objects += ['xmms_icon']

    bld(features = 'c cprogram',
        target = 'xmms2d',
        source = 'main.c',
        includes = '. ../.. ../include ../includepriv',
        uselib = 'math glib2 gmodule2 gthread2 sqlite3 statfs socket shm valgrind',
        use = 'xmms2core',
        add_objects = objects
    )

    bld(features = 'man',
        source = 'xmms2d.1'
    )


## Code fragments for configuration
statfs_fragment = """
#include <sys/param.h>
#include <sys/mount.h>
int main() {
    struct statfs foo;
    return 0;
}
"""
prctl_fragment = """
#include <sys/prctl.h>
int main() {
  return prctl(PR_SET_NAME, (unsigned long) "test", 0, 0, 0);
}
"""
semun_fragment = """
#include <time.h>
#include <sys/sem.h>
int main() {
  union semun foo;
  return 0;
}
"""

def get_statfs_impl(conf):
    # Detect the type of stat call used
    if Options.platform == 'win32':
        return 'dummy'
    else:
        try:
            conf.check(header_name='sys/vfs.h')
        except Errors.ConfigurationError:
            try:
                conf.check(header_name='sys/param.h')
            except Errors.ConfigurationError:
                return 'dummy'
            else:
                try:
                    conf.check_cc(fragment=statfs_fragment,
                                  uselib_store="statfs",
                                  msg="Checking for struct statfs")
                except Errors.ConfigurationError:
                    return 'netbsd'
                else:
                    return 'bsd'
        else:
            if Options.platform == 'sunos':
                return 'solaris'
            else:
                return 'linux'

# Get the implementation variant for the localtime_r function.
def get_localtime_impl(conf):
    try:
        conf.check_cc(function_name='localtime_r', header_name='time.h')
    except Errors.ConfigurationError:
        return 'dummy'
    else:
        return 'unix'

# Get the implementation variant for changing thread name.
def get_thread_name_impl(conf):
    try:
        conf.check(header_name='sys/prctl.h')
        conf.check_cc(fragment=prctl_fragment,
                      msg="Checking for prctl(PR_SET_NAME)")
    except Errors.ConfigurationError:
        return 'dummy'
    else:
        return 'prctl'

# Get the implementation variant for signals, symlinks and uid check.
def get_compat_impl(conf):
    if Options.platform == 'win32':
        return 'dummy'
    else:
        return 'unix'

def get_visualization_impl(conf):
    if conf.options.without_unixshmserver:
        return 'dummy'

    conf.check_cc(function_name='semctl',
                  header_name=['sys/types.h','sys/ipc.h','sys/sem.h'],
                  mandatory=False)
    try:
        conf.check_cc(fragment=semun_fragment, uselib_store="semun",
                      msg = "Checking for union semun")
    except Errors.ConfigurationError:
        conf.env.append_value('DEFINES_shm', "_SEM_SEMUN_UNDEFINED")

    if conf.env.HAVE_SEMCTL:
        return 'unixshm'

    return 'dummy'

def configure(conf):
    conf.check_tool('python-generator', tooldir=os.path.abspath('waftools'))

    conf.check_cfg(package='gmodule-2.0', atleast_version='2.6.0',
            uselib_store='gmodule2', args='--cflags --libs')
    conf.check_cfg(package='gthread-2.0', atleast_version='2.6.0',
            uselib_store='gthread2', args='--cflags --libs')
    conf.check_cfg(package='sqlite3', atleast_version='3.5',
            uselib_store='sqlite3', args='--cflags --libs')

    # Check for the sin function in the math lib
    conf.check_cc(lib='m', function_name='sin', header_name='math.h',
                  uselib_store="math")

    conf.env.compat_impl = get_compat_impl(conf)
    conf.env.statfs_impl = get_statfs_impl(conf)
    conf.env.localtime_impl = get_localtime_impl(conf)
    conf.env.thread_name_impl = get_thread_name_impl(conf)
    conf.env.visualization_impl = get_visualization_impl(conf)

    if conf.env.visualization_impl == 'dummy':
        Logs.warn("Compiling visualization without shm support")

    # Add Darwin stuff
    if Options.platform == 'darwin':
        conf.env.append_value('LINKFLAGS', ['-framework', 'CoreFoundation'])
        conf.env.append_value('DEFINES', 'USE_BUNDLES')

    conf.env.xmms_shared_library = (Options.platform == 'win32')

    conf.env.XMMS_PKGCONF_FILES.append(('xmms2-plugin', ''))

    conf.check_cfg(package='valgrind', uselib_store='valgrind', args='--cflags',
                   mandatory=False)

    return True


def options(opt):
    opt.add_option('--disable-shmvis-server', action='store_true',
                   dest='without_unixshmserver', default=False,
                   help="Disable shared memory support for visualization")

=== doc/tutorial/c++/Makefile ===
LIBS=`pkg-config --libs xmms2-client-cpp`
GLIB=`pkg-config --libs xmms2-client-cpp-glib glib-2.0`

all: tut1 tut2 tut3 tut4 tut5 tut6 tut7 tut8

%.o: %.cc
	g++ `pkg-config --cflags xmms2-client-cpp glib-2.0` -W -Wall -ansi -pedantic -c -o $@ $< 

tut%: tut%.o
	g++ -o $@ $< $(LIBS) $(GLIB)

clean:
	rm -f tut? *.o

=== doc/tutorial/c/Makefile ===
LIBS=`pkg-config --libs xmms2-client`
GLIB=`pkg-config --libs xmms2-client-glib` `pkg-config --libs glib-2.0`

all: tut1 tut2 tut3 tut4 tut5 tut6 tut7 tut8

%.o: %.c
	gcc `pkg-config --cflags xmms2-client glib-2.0` -Wall -c -o $@ $< 

tut%: tut%.o
	gcc -o $@ $< $(LIBS)

tut6: tut6.o
	gcc -o $@ $< $(LIBS) $(GLIB)

tut7: tut7.o
	gcc -o $@ $< $(LIBS) $(GLIB)

tut8: tut8.o
	gcc -o $@ $< $(LIBS) $(GLIB)

clean:
	rm -f tut? *.o

=== src/clients/launcher/wscript ===
import Options

def build(bld):
    bld(features = 'c cprogram',
        target = 'xmms2-launcher',
        source = ['xmms2-launcher.c'],
        includes = '../../.. ../../include',
        uselib = 'glib2',
        use = 'xmmsutils'
        )

    bld(features = 'man',
        source = 'xmms2-launcher.1'
        )

def configure(conf):
    if Options.platform == 'win32':
        conf.fatal("Not supported on Windows")

def options(opt):
    pass

=== src/clients/mdns/wscript ===
from waflib import Errors

def build(bld):
    if bld.env.MDNS_BACKEND in ("avahi", "dns_sd"):
        bld.recurse(bld.env.MDNS_BACKEND)

def configure_backend(conf, backend):
    try:
        conf.recurse(backend, mandatory=True)
    except Errors.ConfigurationError:
        return False
    return True

def configure(conf):
    if conf.options.mdns_backend == "avahi":
        order = ["avahi"]
    elif conf.options.mdns_backend == "dns_sd":
        order = ["dns_sd"]
    else:
        order = ["avahi", "dns_sd"]

    success = False
    for backend in order:
        success = configure_backend(conf, backend)
        if success:
            conf.env.MDNS_BACKEND = backend
            break

    if not success:
        raise Errors.ConfigurationError("No MDNS backend available.")

def options(opt):
    opt.add_option("--with-mdns-backend", dest="mdns_backend",
                   help="Select MDNS backend, avahi or dns_sd", default="")

=== src/clients/medialib-updater/wscript ===
from waflib import Utils

def build(bld):
    bld(features = 'c cprogram',
        target = 'xmms2-mlib-updater',
        source = ['main.c'],
        includes = '. ../../.. ../../include',
        uselib = 'glib2 gio2 gthread2',
        use = 'xmmsclient-glib xmmsclient'
        )

    bld(features = 'subst',
        target = 'xmms2-mlib-updater.sh',
        source = 'xmms2-mlib-updater.sh.in',
        install_path = '${SCRIPTDIR}',
        chmod = Utils.O755,
        PRG_PATH=bld.env.BINDIR
        )


def configure(conf):
    conf.check_cfg(package="gio-2.0", uselib_store='gio2',
            args="--cflags --libs")
    conf.check_cfg(package="gthread-2.0", uselib_store='gthread2',
            args="--cflags --libs")

    conf.check_cc(function_name="g_file_query_file_type",
            header_name="gio/gio.h", uselib="gio2", mandatory=False)


def options(opt):
    pass

=== src/clients/vistest/wscript ===
import Options

def build(bld):
    t = bld(features = 'c cprogram',
        target = 'vistest',
        source = 'vistest.c',
        includes = '. ../../.. ../../include',
        uselib = 'glib2',
        use = 'xmmsclient-glib xmmsclient'
        )
    if not bld.env.INSTALL_VIS_REFERENCE_CLIENTS:
        t.install_path = None

    if bld.env.LIB_math:
        t = bld(features = 'c cprogram',
            target = 'vistest-fft',
            source = 'vistest_fft.c',
            includes = '. ../../.. ../../include',
            uselib = 'glib2 math',
            use = 'xmmsclient-glib xmmsclient'
            )
        if not bld.env.INSTALL_VIS_REFERENCE_CLIENTS:
            t.install_path = None


    if bld.env.LIB_vorbisenc:
        t = bld(features = 'c cprogram',
            target = 'xmms2-ripper',
            source = 'ripper.c',
            includes = '. ../../.. ../../include',
            uselib = 'vorbisenc',
            use = 'xmmsclient'
            )
        if not bld.env.INSTALL_VIS_REFERENCE_CLIENTS:
            t.install_path = None

    if bld.env.LIB_visual and bld.env.LIB_sdl:
        t = bld(features = 'c cprogram',
            target = 'xmms2-libvisual',
            source = 'libvisual.c',
            includes = '. ../../.. ../../include',
            uselib = 'sdl visual DISABLE_STRICTPROTOTYPES',
            use = 'xmmsclient'
            )
        if not bld.env.INSTALL_VIS_REFERENCE_CLIENTS:
            t.install_path = None

def configure(conf):
    if Options.platform == "win32":
        conf.fatal("visualisation clients not supported on windows")

    conf.env.INSTALL_VIS_REFERENCE_CLIENTS = conf.options.with_vis_clients

    conf.check_cc(lib="m", uselib_store="math", mandatory=False)

    conf.check_cfg(package='vorbisenc', uselib_store='vorbisenc',
            args='--cflags --libs', mandatory=False)

    if conf.check_cfg(package='libvisual-0.4', uselib_store='visual',
            args='--cflags --libs', mandatory=False):
        conf.check_cfg(package='sdl', uselib_store='sdl',
                args='--cflags --libs', mandatory=False)


def options(opt):
    opt.add_option('--with-vis-reference-clients',
                   action='store_true', default=False,
                   dest='with_vis_clients',
                   help="Install the visualization reference clients")

=== src/include/xmms/wscript ===
import os, sys
from waflib import Options, Logs

def build(bld):
    pass


def configure(conf):
    """Set the values needed by xmms_defs.h.in in the environment."""

    # Get default output plugin
    l = sorted(conf.env.XMMS_OUTPUT_PLUGINS)
    prio, outdefault = l[-1]
    if not conf.options.without_xmms2d and prio == -1:
        Logs.warn("No output plugin found, this is bad!")
    if conf.options.default_output_plugin:
        preferred = conf.options.default_output_plugin
        if preferred in [o[1] for o in l]:
            outdefault = preferred
        else:
            conf.fatal('The "%s" output plugin could not be found.' % (preferred))

    if Options.platform == 'darwin':
        uconf = 'Library/xmms2'
        ucache = 'Library/xmms2/logs'
    else:
        uconf = '.config/xmms2'
        ucache = '.cache/xmms2'

    sharedir = os.path.join(conf.env.DATADIR, 'xmms2')
    if Options.platform == 'win32':
        # The plugin path in Windows should be relative, not absolute
        conf.env.PLUGINDIR = 'Plugins/'
    else:
        conf.env.PLUGINDIR = os.path.join(conf.env.LIBDIR, 'xmms2')

    defs = dict(
        PKGLIBDIR = conf.env.PLUGINDIR,
        BINDIR = conf.env.BINDIR,
        SHAREDDIR = sharedir,
        SCRIPTDIR = os.path.join(sharedir, 'scripts', 'startup.d'),
        XMMS_VERSION = conf.env.VERSION,
        XMMS_OUTPUT_DEFAULT = outdefault,
        USERCONFDIR = uconf,
        USERCACHEDIR = ucache,
        SYSCONFDIR = '/etc/xmms2',
    )

    conf.env.update(defs)

    for i in defs:
        conf.define(i, defs[i])

    if not conf.options.without_xmms2d:
        Logs.pprint('Normal', "\nDefault output plugin: ", sep='')
        Logs.pprint('BLUE', outdefault)

    return True


def options(opt):
    pass

=== debian/changelog ===
xmms2 (0.8+dfsg-29) unstable; urgency=medium

  * QA upload
  * Switch to libopenmpt-modplug-dev

 -- Sebastian Ramacher <sramacher@debian.org>  Fri, 26 Sep 2025 12:45:47 +0200

xmms2 (0.8+dfsg-28) unstable; urgency=medium

  * QA upload
  * d/copyright: Convert to machine-readable format
  * Fix lintian date warning
  * Drop python3-xmmsclient (Closes: #1087580)

 -- Bastian Germann <bage@debian.org>  Wed, 11 Dec 2024 22:25:55 +0000

xmms2 (0.8+dfsg-27) unstable; urgency=medium

  * QA upload
  * Fix FTBFS with gcc-14. (Closes: #1075672, LP: #2080596)
  * Fix FTBFS with ffmpeg 7. (Closes: #1072462, LP: #2080640)

 -- Paul Mars <paul.mars@canonical.com>  Thu, 19 Sep 2024 15:55:22 +0200

xmms2 (0.8+dfsg-26) unstable; urgency=medium

  * QA upload

  [ Sudip Mukherjee <sudipm.mukherjee@gmail.com> ]
  * Fix coredump with long pathnames. (LP: #2018449)

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 25 Jun 2024 11:38:46 +0200

xmms2 (0.8+dfsg-25) unstable; urgency=medium

  * QA upload
  * Move to Depends: pkgconf
  * Prevent waf distclean

  [ Axel Beckert ]
  * Drop Homepage, Move d/{copyright,watch} to GitHub

  [ Samuel Thibault ]
  * d/control: Generalize hurd-i386 into hurd-any

 -- Bastian Germann <bage@debian.org>  Sat, 22 Jun 2024 17:04:38 +0000

xmms2 (0.8+dfsg-24) unstable; urgency=medium

  * QA upload.
  * Build-depend on cython3-legacy instead of cython3. Closes: #1056894.
  * xmms2: Curl plugin: intermediate buffer overrun (patch provided by
    Luc Verhaegen). Closes: #1009108.

 -- Matthias Klose <doko@debian.org>  Sun, 26 Nov 2023 11:19:39 +0100

xmms2 (0.8+dfsg-23) unstable; urgency=medium

  * QA upload.
  * Fix FTBFS with ffmpeg 5.0, thanks to Dan Bungert.  (Closes: #1004805)
  * Drop alternate dependency on obsolete ruby-interpreter.
  * Drop NEWS from 2006.
  * Set Rules-Requires-Root: no.

 -- Andreas Beckmann <anbe@debian.org>  Fri, 02 Jun 2023 10:08:57 +0200

xmms2 (0.8+dfsg-22) unstable; urgency=medium

  * QA upload.
  * debian/rules: set --libdir=/usr/lib to fix a strange build failure on
    ppc64el.

 -- Steve Langasek <vorlon@debian.org>  Thu, 18 Nov 2021 02:00:46 +0000

xmms2 (0.8+dfsg-21) unstable; urgency=medium

  * QA upload.
  * Remove build-dependency libgamin-dev.
    Apparently unused since the 0.7DrNo release.

 -- Chris Hofstaedtler <zeha@debian.org>  Sat, 06 Feb 2021 12:55:30 +0000

xmms2 (0.8+dfsg-20) unstable; urgency=medium

  * QA upload.
  * Incorporate changes from 0.8+dfsg-18.3 NMU
  * Add build dependency on libpod-parser-perl (Closes: #961151)

 -- Scott Talbert <swt@techie.net>  Fri, 19 Jun 2020 15:58:18 -0400

xmms2 (0.8+dfsg-19) unstable; urgency=medium

  * QA upload.
  * Update VCS URLs to Salsa
  * Upgrade bundled waf to 2.0.20 to support Python 3.8
  * Patch to use more modern waf in wscripts
  * Fix Python enum declaration
  * Switch to use Python 3 (Closes: #938852)
  * Set Maintainer to QA group as package is orphaned
  * Update debhelper compat version to 13
  * Add lintian overrides for library-not-linked-against-libc (false pos)

 -- Scott Talbert <swt@techie.net>  Sun, 24 May 2020 21:15:44 -0400

xmms2 (0.8+dfsg-18.3) unstable; urgency=medium

  * Non-maintainer upload.
  * Remove liboost-signals-dev from Build-Depends. (Closes: #955581)

 -- Sebastian Ramacher <sramacher@debian.org>  Tue, 09 Jun 2020 00:19:53 +0200

xmms2 (0.8+dfsg-18.2) unstable; urgency=high

  * Non-maintainer upload.
  * Build using GCC 8 and tighten dependency on the shared library. Closes:
    #871285

 -- Emanuele Rocca <ema@debian.org>  Mon, 25 Feb 2019 08:12:48 +0100

xmms2 (0.8+dfsg-18.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Build with -Wno-deprecated-declarations using new glib.
  * Fix build with new libcdio-paranoia. Closes: #881797.

 -- Matthias Klose <doko@debian.org>  Thu, 16 Nov 2017 13:54:03 +0100

xmms2 (0.8+dfsg-18) unstable; urgency=medium

  * Remove glib version check (Closes: #849373)
  * Update Vcs links to point to https URLs
  * Mention Perl library name in description of libaudio-xmmsclient-perl

 -- Benjamin Drung <bdrung@debian.org>  Mon, 02 Jan 2017 22:46:43 +0100

xmms2 (0.8+dfsg-17) unstable; urgency=medium

  * Bug fix: "FTBFS with openssl 1.1.0", thanks to Sebastian Andrzej
    Siewior (Closes: #828609).
  * Bump Standards-Version to 3.9.8 (no changes needed).

 -- Rémi Vanicat <vanicat@debian.org>  Sat, 29 Oct 2016 21:17:05 +0200

xmms2 (0.8+dfsg-16) unstable; urgency=medium

  * OTHER: Let the compiler figure out what to inline.
    (thanks to Daniel Svensson <dsvensson@gmail.com>,
    fix: "equalizer not working", thanks to dave (Closes: #825017).

 -- Rémi Vanicat <vanicat@debian.org>  Sun, 22 May 2016 19:50:17 +0200

xmms2 (0.8+dfsg-15) unstable; urgency=medium

  * remove samba on hurd-i386 (Closes: #815410).
    thanks to Andreas Beckmann

 -- Rémi Vanicat <vanicat@debian.org>  Sun, 21 Feb 2016 14:16:33 +0100

xmms2 (0.8+dfsg-14) unstable; urgency=medium

  * transition do g++-5 (Closes: #797646)
    rename libxmmsclient++4 to libxmmsclient++4v5
    rename libxmmsclient++-glib1 to libxmmsclient++-glib1v5

 -- Rémi Vanicat <vanicat@debian.org>  Sun, 06 Sep 2015 11:59:37 +0200

xmms2 (0.8+dfsg-13) unstable; urgency=low

  * xmms2-plugin-gme: list supported formats in description, thanks to
    Samuel Bronson (Closes: #780075).
  * Bug fix: "FTBFS: uses obsolete ruby Config::CONFIG", thanks to Andreas
    Cadhalpun and Christian Hofstaedtler (Closes: #792493, #782259).
  * Bump Standards-Version to 3.9.6 (no changes needed).

 -- Rémi Vanicat <vanicat@debian.org>  Tue, 21 Jul 2015 15:07:37 +0200

xmms2 (0.8+dfsg-12) unstable; urgency=medium

  * Do not build vistest (Closes: #768679)

 -- Rémi Vanicat <vanicat@debian.org>  Sun, 09 Nov 2014 11:44:03 +0100

xmms2 (0.8+dfsg-11) unstable; urgency=low

  * Use a virtual package (xmms2-plugin-output) to allow not installing the
    alsa plugin (Closes: #499950).
  * Perl 5.20 transition: make libaudio-xmmsclient-perl.install an


=== debian/control ===
Source: xmms2
Section: sound
Priority: optional
Maintainer: Debian QA Group <packages@qa.debian.org>
Standards-Version: 3.9.8
Build-Depends:
               debhelper-compat (= 13),
               gem2deb,
               libao-dev,
               libasound2-dev [linux-any],
               libavahi-client-dev,
               libavahi-glib-dev,
               libavcodec-dev (>= 6:10~),
               libboost-dev,
               libcdio-cdda-dev,
               libcurl4-openssl-dev,
               libdiscid-dev,
               libexpat1-dev,
               libfaad-dev,
               libfftw3-dev,
               libflac-dev,
               libglib2.0-dev,
               libgme-dev,
               libjack-dev,
               libmad0-dev,
               libmms-dev,
               libmpcdec-dev,
               libmpg123-dev (>= 1.5.1),
               libofa0-dev,
               libopenmpt-modplug-dev,
               libperl-dev,
               libpod-parser-perl,
               libpulse-dev,
               libreadline-dev,
               libresid-builder-dev,
               libsamplerate-dev,
               libsdl1.2-dev,
               libshout-dev,
               libsidplay2-dev,
               libsmbclient-dev [!hurd-any],
               libsndfile1-dev,
               libsqlite3-dev,
               libssl-dev,
               libvisual-0.4-dev,
               libvorbis-dev,
               libwavpack-dev,
               libxml2-dev,
Rules-Requires-Root: no
Vcs-Git: https://salsa.debian.org/debian/xmms2.git
Vcs-Browser: https://salsa.debian.org/debian/xmms2

Package: libaudio-xmmsclient-perl
Architecture: any
Section: perl
Depends: ${misc:Depends}, ${perl:Depends}, ${shlibs:Depends}
Description: XMMS2 - Perl client library
 XMMS2 is a redesign of the XMMS music player. It features a client-server
 model, allowing multiple (even simultaneous!) user interfaces, both textual
 and graphical. All common audio formats are supported using plug-ins. On top of
 this, there is a flexible media library to organize your music.
 .
 This package contains the Perl library Audio::Xmmsclient that allows you to
 write XMMS2 clients. It's a language binding of libxmmsclient0.

Package: libxmmsclient++-dev
Architecture: any
Section: libdevel
Depends: libboost-dev,
         libxmmsclient++4v5 (= ${binary:Version}),
         libxmmsclient-dev,
         pkgconf,
         ${misc:Depends}
Description: XMMS2 - client library for c++ - development files
 XMMS2 is a redesign of the XMMS music player. It features a client-server
 model, allowing multiple (even simultaneous!) user interfaces, both textual
 and graphical. All common audio formats are supported using plug-ins. On top of
 this, there is a flexible media library to organize your music.
 .
 This package contains files for developing XMMS2 clients using
 libxmmsclient++4v5.

Package: libxmmsclient++-glib-dev
Architecture: any
Section: libdevel
Depends: libxmmsclient++-dev,
         libxmmsclient++-glib1v5 (= ${binary:Version}),
         libxmmsclient-glib-dev,
         pkgconf,
         ${misc:Depends}
Description: XMMS2 - glib client library for c++ - development files
 XMMS2 is a redesign of the XMMS music player. It features a client-server
 model, allowing multiple (even simultaneous!) user interfaces, both textual
 and graphical. All common audio formats are supported using plug-ins. On top of
 this, there is a flexible media library to organize your music.
 .
 This package contains files for developing XMMS2 clients using
 libxmmsclient++-glib1v5.

Package: libxmmsclient++-glib1v5
Architecture: any
Section: libs
Depends: ${misc:Depends}, ${shlibs:Depends}
Conflicts: libxmmsclient++-glib1
Replaces: libxmmsclient++-glib1
Description: XMMS2 - glib client library for c++
 XMMS2 is a redesign of the XMMS music player. It features a client-server
 model, allowing multiple (even simultaneous!) user interfaces, both textual
 and graphical. All common audio formats are supported using plug-ins. On top of
 this, there is a flexible media library to organize your music.
 .
 This package contains a glib based client library written in c++.

Package: libxmmsclient++4v5
Architecture: any
Section: libs
Depends: ${misc:Depends}, ${shlibs:Depends}
Conflicts: libxmmsclient++1,
           libxmmsclient++2,
           libxmmsclient++3,
           libxmmsclient++4
Replaces: libxmmsclient++1,
          libxmmsclient++2,
          libxmmsclient++3,
          libxmmsclient++4
Breaks: xmms2-core (<< 0.6DrMattDestruction)
Description: XMMS2 - client library for c++
 XMMS2 is a redesign of the XMMS music player. It features a client-server
 model, allowing multiple (even simultaneous!) user interfaces, both textual
 and graphical. All common audio formats are supported using plug-ins. On top of
 this, there is a flexible media library to organize your music.
 .
 This package contains a client library written in c++.

Package: libxmmsclient-dev
Architecture: any
Section: libdevel
Depends: libxmmsclient6 (= ${binary:Version}),
         pkgconf,
         xmms2-dev,
         ${misc:Depends}
Description: XMMS2 - client library development files
 XMMS2 is a redesign of the XMMS music player. It features a client-server
 model, allowing multiple (even simultaneous!) user interfaces, both textual
 and graphical. All common audio formats are supported using plug-ins. On top of
 this, there is a flexible media library to organize your music.
 .
 This package contains files for developing XMMS2 clients using libxmmsclient6.

Package: libxmmsclient-glib-dev
Architecture: any
Section: libdevel
Depends: libglib2.0-dev,
         libxmmsclient-dev,
         libxmmsclient-glib1 (= ${binary:Version}),
         pkgconf,
         ${misc:Depends}
Description: XMMS2 - glib client library - development files
 XMMS2 is a redesign of the XMMS music player. It features a client-server
 model, allowing multiple (even simultaneous!) user interfaces, both textual
 and graphical. All common audio formats are supported using plug-ins. On top of
 this, there is a flexible media library to organize your music.
 .
 This package contains files for developing XMMS2 clients using
 libxmmsclient-glib1.

Package: libxmmsclient-glib1
Architecture: any
Section: libs
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: XMMS2 - glib client library
 XMMS2 is a redesign of the XMMS music player. It features a client-server
 model, allowing multiple (even simultaneous!) user interfaces, both textual
 and graphical. All common audio formats are supported using plug-ins. On top of
 this, there is a flexible media library to organize your music.
 .
 This package contains a glib based client library written in c.

Package: ruby-xmmsclient
Architecture: any
Section: ruby
Depends: ruby, ${misc:Depends}, ${shlibs:Depends}
Description: XMMS2 - Ruby bindings
 XMMS2 is a redesign of the XMMS music player. It features a client-server
 model, allowing multiple (even simultaneous!) user interfaces, both textual
 and graphical. All common audio formats are supported using plug-ins. On top of
 this, there is a flexible media library to organize your music.
 .
 This package contains a Ruby library that allows you to write XMMS2 clients.
 It's a language binding of libxmmsclient0.

Package: libxmmsclient6
Architecture: any
Section: libs
Conflicts: libxmmsclient2, libxmmsclient3, libxmmsclient4, libxmmsclient5
Replaces: libxmmsclient2, libxmmsclient3, libxmmsclient4, libxmmsclient5
Depends: ${misc:Depends}, ${shlibs:Depends}
Breaks: xmms2-core (<< 0.6DrMattDestruction)
Description: XMMS2 - client library
 XMMS2 is a redesign of the XMMS music player. It features a client-server
 model, allowing multiple (even simultaneous!) user interfaces, both textual
 and graphical. All common audio formats are supported using plug-ins. On top of
 this, there is a flexible media library to organize your music.
 .
 This package contains a client library written in c.

Package: xmms2
Architecture: any
Depends: xmms2-client-cli,
         xmms2-core,
         xmms2-icon,
         xmms2-plugin-alsa [linux-any] | xmms2-plugin-oss [!linux-any] | xmms2-plugin-output,
         xmms2-plugin-id3v2,
         xmms2-plugin-mad,
         xmms2-plugin-vorbis,
         ${misc:Depends}
Conflicts: xmms2-plugin-nulstripper
Replaces: xmms2-plugin-nulstripper
Description: Client/server based media player system
 XMMS2 is a redesign of the XMMS music player. It features a client-server
 model, allowing multiple (even simultaneous!) user interfaces, both textual
 and graphical. All common audio formats are supported using plug-ins. On top of
 this, there is a flexible media library to organize your music.
 .
 This package is a metapackage depending on various other XMMS2 packages.
 Installing this package gets you a command line client and enables XMMS2
 playback of Ogg Vorbis and MP3 files from local and remote sources.

Package: xmms2-client-avahi
Architecture: any
Depends: xmms2-core (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
Description: XMMS2 - avahi client
 XMMS2 is a redesign of the XMMS music player. It features a client-server
 model, allowing multiple (even simultaneous!) user interfaces, both textual
 and graphical. All common audio formats are supported using plug-ins. On top of
 this, there is a flexible media library to organize your music.
 .
 This package contains the avahi client.

Package: xmms2-client-cli
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Suggests: xmms2-core (= ${binary:Version})
Description: XMMS2 - cli client
 XMMS2 is a redesign of the XMMS music player. It features a client-server
 model, allowing multiple (even simultaneous!) user interfaces, both textual
 and graphical. All common audio formats are supported using plug-ins. On top of
 this, there is a flexible media library to organize your music.
 .
 This package contains the readline powered text user interface for XMMS2.

Package: xmms2-client-medialib-updater
Architecture: any
Depends: xmms2-core (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
Description: XMMS2 - medialib-updater client
 The media library is where XMMS2 stores metadata about files as it plays them.
 Having a media library allows XMMS2 to 'remember' the songs it has played, and
 thus allows users to easily re-create their favorite playlists.
 .
 This package contains the medialib-updater client which monitors given
 directories and updates the media library with new and changed files.

Package: xmms2-client-nycli
Architecture: any
Depends: xmms2-client-cli, ${misc:Depends}
Suggests: xmms2-core (= ${binary:Version})
Description: XMMS2 - new cli client
 XMMS2 is a redesign of the XMMS music player. It features a client-server
 model, allowing multiple (even simultaneous!) user interfaces, both textual
 and graphical. All common audio formats are supported using plug-ins. On top of
 this, there is a flexible media library to organize your music.
 .
 This package contains only the symlink from nyxmms2 to xmms2. nyxmms2 was
 renamed to xmms2 in 0.8 DrO_o.

Package: xmms2-core
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Conflicts: libxmmsclient++1,
           libxmmsclient++2,
           libxmmsclient++3,
           libxmmsclient++4,
           libxmmsclient2,
           libxmmsclient3,
           libxmmsclient4
Description: XMMS2 - core package
 XMMS2 is a redesign of the XMMS music player. It features a client-server
 model, allowing multiple (even simultaneous!) user interfaces, both textual
 and graphical. All common audio formats are supported using plug-ins. On top of
 this, there is a flexible media library to organize your music.
 .
 This package just contains the daemon that loads plug-ins and allows clients to
 connect.

Package: xmms2-dev
Architecture: all
Section: libdevel
Depends: pkgconf, ${misc:Depends}
Description: XMMS2 - plug-in development files
 XMMS2 is a redesign of the XMMS music player. It features a client-server

=== debian/rules ===
#!/usr/bin/make -f

export NOCOLOR=1

RUBYVERSIONS := $(shell dh_ruby --print-supported)
VENDOR ?= $(shell if dpkg-vendor --is Ubuntu || dpkg-vendor --derives-from Ubuntu; then echo "Ubuntu"; else echo "Debian"; fi)

ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
	NUMJOBS := $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
else
	NUMJOBS := 1
endif

ifeq ($(DEB_HOST_ARCH_OS), kfreebsd)
	NUMJOBS := 1
endif

WAFFLAGS := --prefix=/usr --libdir=/usr/lib -j $(NUMJOBS)
ifeq ($(VENDOR),Ubuntu)
additional_wafflags := --with-default-output-plugin=pulse
endif

define \n


endef

export DEB_CFLAGS_MAINT_APPEND = -DHAVE_G_FILE_QUERY_FILE_TYPE

%:
	dh $@

override_dh_auto_clean:
	rm -rf _build_*_
	dh_clean
	# Clean up after waf
	find waflib waftools -name '*.pyc' -delete

override_dh_auto_configure:
	./waf configure $(WAFFLAGS) \
		--with-perl-archdir=$(shell /usr/bin/perl -MConfig -le'print $$Config{vendorarch}') \
		--with-perl-binary=/usr/bin/perl \
		--without-optionals=ruby,et,python,vistest $(additional_wafflags)
	mv _build_ _build_without_python_
	$(foreach rubyversion,$(RUBYVERSIONS),\
		RUBY=/usr/bin/$(rubyversion) ./waf configure $(WAFFLAGS) --without-xmms2d --with-optionals=ruby \
		--with-ruby-archdir=$(shell $(rubyversion) -rrbconfig -e'print RbConfig::CONFIG["vendorarchdir"]') \
		--with-ruby-libdir=$(shell $(rubyversion) -rrbconfig -e'print RbConfig::CONFIG["vendordir"]') && \
		mv _build_ _build_$(rubyversion)_$(\n))

override_dh_auto_build:
	$(foreach pyversion,without_python $(RUBYVERSIONS),\
		mv _build_$(pyversion)_ _build_ && \
		./waf -v && \
		mv _build_ _build_$(pyversion)_$(\n))

override_dh_auto_install:
	$(foreach pyversion,without_python $(RUBYVERSIONS),\
		mv _build_$(pyversion)_ _build_ && \
		./waf install --destdir=$(CURDIR)/debian/tmp --without-ldconfig && \
		mv _build_ _build_$(pyversion)_$(\n))
ifeq ($(VENDOR),Ubuntu)
	echo "misc:Depends=xmms2-plugin-pulse" >> debian/xmms2.substvars
endif

override_dh_makeshlibs:
	# For new symbols when compiled with GCC >= 7
	dh_makeshlibs -V'libxmmsclient++4v5 (>= 0.8+dfsg-18.2~)'

=== debian/watch ===
version=3
opts=dversionmangle=s/\+dfsg\d*$// https://github.com/xmms2/xmms2-devel/tags .*/(.*).tar.gz
